﻿unit NothingBabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs;

type
  TNothingBabel = class(TGraphicControl)
  private
    fLanguage: string;
    FActive: Boolean;
    procedure SetLanguage(const Value: string);
    procedure SetActive(const Value: Boolean);
  const
    nuEnglishText = 'Nothing here';
  public
    constructor Create (Owner: TComponent); override;
    procedure UpdateHint;
  published
    property Width default 50;
    property Height default 50;
    property Align;
    property ShowHint;
    property Visible;
    property Enabled;
    property OnClick;
    property OnDblClick;
    property OnMouseDown;
    property OnMouseUp;
    property OnMouseMove;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnStartDrag;
    property Language: string
      read fLanguage write SetLanguage;
    property Active: Boolean
      read FActive write SetActive;
  end;

procedure Register;

implementation

uses
  BabelGoogle;


constructor TNothingBabel.Create (Owner: TComponent);
begin
  // call parent class constructor first
  inherited Create (Owner);
  // set the size
  Width := 50;
  Height := 50;

  fLanguage := 'EN';
  Hint := nuEnglishText;
end;

procedure Register;
begin
  RegisterComponents('FunSide', [TNothingBabel]);
end;

procedure TNothingBabel.SetActive(const Value: Boolean);
begin
  if fActive <> Value then
  begin
    FActive := Value;
    if FActive then
      UpdateHint;
  end;

end;

procedure TNothingBabel.SetLanguage(const Value: string);
begin
  if fLanguage <> Value then
  begin
    fLanguage := Value;
    if Active then
      UpdateHint;
  end;
end;

procedure TNothingBabel.UpdateHint;
begin
  Hint := TBabelGoogle.Translate (nuEnglishText, 'en', fLanguage);
end;

end.
