﻿unit NothingUni;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs;

type
  TNULanguage = (nuEnglish, nuChinese, nuGreek, nuRussian, nuSpanish);

type
  TNothingUni = class(TGraphicControl)
  private
    fLanguage: TNULanguage;
    procedure SetLanguage(const Value: TNULanguage);
  const
    nuEnglishText = 'Nothing here';
    nuChineseText = '没什么这里';
    nuGreekText = 'τίποτα εδώ';
    nuRussianText = 'ничего здесь';
    nuSpanishText = 'nada aquí';
  public
    constructor Create (Owner: TComponent); override;
  published
    property Width default 50;
    property Height default 50;
    property Align;
    property ShowHint;
    property Visible;
    property Enabled;
    property OnClick;
    property OnDblClick;
    property OnMouseDown;
    property OnMouseUp;
    property OnMouseMove;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnStartDrag;
    property Language: TNULanguage
      read fLanguage write SetLanguage default nuEnglish;
  end;

procedure Register;

implementation

constructor TNothingUni.Create (Owner: TComponent);
begin
  // call parent class constructor first
  inherited Create (Owner);
  // set the size
  Width := 50;
  Height := 50;

  fLanguage := nuEnglish;
  Hint := nuEnglishText;
end;

procedure Register;
begin
  RegisterComponents('FunSide', [TNothingUni]);
end;

procedure TNothingUni.SetLanguage(const Value: TNULanguage);
begin
  fLanguage := Value;
  case fLanguage of
    nuEnglish: Hint := nuEnglishText;
    nuChinese: Hint := nuChineseText;
    nuGreek: Hint := nuGreekText;
    nuRussian: Hint := nuRussianText;
    nuSpanish: Hint := nuSpanishText;
  end;
end;

end.
