unit UniCharViewer;

interface

uses
  SysUtils, Classes, Controls;

type
  TUniCharViewer = class(TGraphicControl)
  private
    FTheChar: Char;
    procedure SetCodePoint(const Value: Cardinal);
    procedure SetTheChar(const Value: Char);
    function GetCodePoint: Cardinal;
  protected
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property TheChar: Char read FTheChar write SetTheChar default 'a';
    property CodePoint: Cardinal read GetCodePoint
      write SetCodePoint stored False;
    property Font;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('FunSide', [TUniCharViewer]);
end;

{ TUniCharViewer }

constructor TUniCharViewer.Create(AOwner: TComponent);
begin
  inherited;
  Width := 100;
  Height := 100;
  TheChar := 'a';
end;

function TUniCharViewer.GetCodePoint: Cardinal;
begin
  Result := Ord (FTheChar);
end;

procedure TUniCharViewer.Paint;
begin
  Canvas.Font := Font;
  Canvas.TextOut(1, 1, string (FTheChar));
end;

procedure TUniCharViewer.SetCodePoint(const Value: Cardinal);
begin
  FTheChar := Chr (Value);
  Invalidate;
end;

procedure TUniCharViewer.SetTheChar(const Value: Char);
begin
  FTheChar := Value;
  Invalidate;
end;

end.

