unit googletranslateform;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, SHDocVw, ExtCtrls;

type
  TFormGoogleTranslate = class(TForm)
    WebBrowser1: TWebBrowser;
    Button1: TButton;
    Button2: TButton;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure WebBrowser1DocumentComplete(ASender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure WebBrowser1DownloadComplete(Sender: TObject);
    procedure WebBrowser1NavigateComplete2(ASender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure Timer1Timer(Sender: TObject);
  private
    strResult: string;
    procedure GrabResult;
  public
    function DoTranslate (const strIn, langFrom, LangTo: string): string;
  end;

function FormGoogleTranslate: TFormGoogleTranslate;

implementation

uses
  idUri, strUtils;

{$R *.dfm}

var
  FFormGoogleTranslate: TFormGoogleTranslate = nil;

// create once and keep around
function FormGoogleTranslate: TFormGoogleTranslate;
begin
  if not Assigned (FFormGoogleTranslate) then
    FFormGoogleTranslate := TFormGoogleTranslate.Create(Application);
  Result := FFormGoogleTranslate;
end;

procedure TFormGoogleTranslate.Button1Click(Sender: TObject);
var
  strUrl: string;
begin
  strUrl := Format (
    'http://translate.google.com/translate_t?hl=%s#%s|%s|%s',
    ['EN', 'EN', 'hi', 'Nothing here']);
  strUrl := TIdUri.URLEncode(strUrl);
  WebBrowser1.Navigate('http://translate.google.com/translate_t?hl=en#en|bg|nothing%20here');
end;

procedure TFormGoogleTranslate.Button2Click(Sender: TObject);
begin
  GrabResult;
end;

procedure TFormGoogleTranslate.GrabResult;
var
  strHtml: string;
  nPosA, nPosB: Integer;
begin
  strHtml := WebBrowser1.OleObject.Document.DocumentElement.InnerHTML;
  nPosA := Pos ('id=result_box', strHtml); // open tag
  nPosA := PosEx ('>', strHtml, nPosA) + 1; // open tag end
  nPosB := PosEx ('<', strHtml, nPosA) - 1;
  strResult := Copy (strHtml, nPosA, nPosB - nPosA + 1);
  Caption := strResult;
end;

function TFormGoogleTranslate.DoTranslate(const strIn, langFrom,
  LangTo: string): string;
var
  strUrl: string;
begin
  strResult := '';

  strUrl := Format (
    'http://translate.google.com/translate_t?hl=%s#%s|%s|%s',
    [langFrom, langFrom, langTo,
    TIdUri.ParamsEncode (strIn)]);
    // nope!!!
    // strUrl := TIdUri.URLEncode(strUrl);
  WebBrowser1.Navigate(strUrl);
    // debug: 'http://translate.google.com/translate_t?hl=en#en|bg|nothing%20here');

  // aaargh!
  while strResult = '' do
    Application.ProcessMessages;

  Result := strResult;
end;

procedure TFormGoogleTranslate.Timer1Timer(Sender: TObject);
begin
  GrabResult;
  if strResult <> '' then
    Timer1.Enabled := False;
end;

procedure TFormGoogleTranslate.WebBrowser1DocumentComplete(ASender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  // one: too early
end;

procedure TFormGoogleTranslate.WebBrowser1DownloadComplete(Sender: TObject);
begin
  // two: way too early
  // Button2Click(nil);
end;

procedure TFormGoogleTranslate.WebBrowser1NavigateComplete2(ASender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  Timer1.Enabled := True;
end;

end.
